﻿/* ============================================================
* Author:       liubingsheng
* Time:         2016/11/29 14:52:25
* FileName:     RedisSystem
* Purpose:      Redis
* =============================================================*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;

namespace Utility
{
    public static partial class TaskEx
    {
        /// <summary>
        /// 等待所有
        /// </summary>
        /// <typeparam name="TResult"></typeparam>
        /// <typeparam name="T1"></typeparam>
        /// <param name="lstParams"></param>
        /// <param name="func"></param>
        /// <returns></returns>
        public static List<TResult> WhenAll<TResult, T1>(IEnumerable<T1> lstParams, Func<T1, TResult> func)
        {
            var lstTasks = new List<TResult>();
            foreach (var item in lstParams)
            {
                var task = func(item);
                lstTasks.Add(task);
            }

            var arrResults = lstTasks;
            return arrResults.ToList();
        }


        /// <summary>
        /// 去除list里面的task
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="list"></param>
        /// <returns></returns>
        public async static Task<List<T>> RemoveTask<T>(List<Task<T>> list)
        {
            List<T> listResult = new List<T>();

            foreach (var item in list)
            {
                listResult.Add(await item);
            }
            return listResult;
        }

        /// <summary>
        /// 等待所有
        /// </summary>
        /// <typeparam name="T1"></typeparam>
        /// <param name="lstParams"></param>
        /// <param name="func"></param>
        /// <returns></returns>
        public static async Task WhenAll<T1>(IEnumerable<T1> lstParams, Func<T1, Task> func)
        {
            var lstTasks = new List<Task>();
            foreach (var item in lstParams)
            {
                var task = func(item);
                lstTasks.Add(task);
            }

            await Task.WhenAll(lstTasks);
        }

        public static TaskAwaiter GetAwaiter(this IEnumerable<Task> tasks)
        {
            return Task.WhenAll(tasks).GetAwaiter();
        }

        public static TaskAwaiter GetAwaiter(this TimeSpan timeSpan)
        {
            return Task.Delay(timeSpan).GetAwaiter();
        }
    }
}
